Index: django/templatetags/i18n.py
===================================================================
--- django/templatetags/i18n.py	(revision 11593)
+++ django/templatetags/i18n.py	(working copy)
@@ -1,8 +1,10 @@
 import re
 
-from django.template import Node, Variable, VariableNode, _render_value_in_context
+from django.template import Node, _render_value_in_context
 from django.template import TemplateSyntaxError, TokenParser, Library
 from django.template import TOKEN_TEXT, TOKEN_VAR
+from django.template.utils import parse_context_bindings, parse_as, resolve_dict
+from django.template.parser import uses_token_stream
 from django.utils import translation
 from django.utils.encoding import force_unicode
 
@@ -35,7 +37,7 @@
 
 class TranslateNode(Node):
     def __init__(self, value, noop):
-        self.value = Variable(value)
+        self.value = value
         self.noop = noop
 
     def render(self, context):
@@ -66,9 +68,7 @@
         return ''.join(result), vars
 
     def render(self, context):
-        tmp_context = {}
-        for var, val in self.extra_context.items():
-            tmp_context[var] = val.render(context)
+        tmp_context = resolve_dict(self.extra_context, context)
         # Update() works like a push(), so corresponding context.pop() is at
         # the end of function
         context.update(tmp_context)
@@ -141,7 +141,8 @@
         raise TemplateSyntaxError, "'get_current_language_bidi' requires 'as variable' (got %r)" % args
     return GetCurrentLanguageBidiNode(args[2])
 
-def do_translate(parser, token):
+#@uses_token_stream
+def do_translate(parser, bits):
     """
     This will mark a string for translation and will
     translate the string for the current language.
@@ -171,21 +172,12 @@
     the variable ``variable``. Make sure that the string
     in there is something that is in the .po file.
     """
-    class TranslateParser(TokenParser):
-        def top(self):
-            value = self.value()
-            if self.more():
-                if self.tag() == 'noop':
-                    noop = True
-                else:
-                    raise TemplateSyntaxError, "only option for 'trans' is 'noop'"
-            else:
-                noop = False
-            return (value, noop)
-    value, noop = TranslateParser(token.contents).top()
+    value = bits.parse_expression(required=True)
+    noop = bits.pop_lexeme('noop')
     return TranslateNode(value, noop)
 
-def do_block_translate(parser, token):
+#@uses_token_stream
+def do_block_translate(parser, bits):
     """
     This will translate a block of text with parameters.
 
@@ -205,29 +197,15 @@
 
     This is much like ngettext, only in template syntax.
     """
-    class BlockTranslateParser(TokenParser):
-        def top(self):
-            countervar = None
-            counter = None
-            extra_context = {}
-            while self.more():
-                tag = self.tag()
-                if tag == 'with' or tag == 'and':
-                    value = self.value()
-                    if self.tag() != 'as':
-                        raise TemplateSyntaxError, "variable bindings in 'blocktrans' must be 'with value as variable'"
-                    extra_context[self.tag()] = VariableNode(
-                            parser.compile_filter(value))
-                elif tag == 'count':
-                    counter = parser.compile_filter(self.value())
-                    if self.tag() != 'as':
-                        raise TemplateSyntaxError, "counter specification in 'blocktrans' must be 'count value as variable'"
-                    countervar = self.tag()
-                else:
-                    raise TemplateSyntaxError, "unknown subtag %s for 'blocktrans' found" % tag
-            return (countervar, counter, extra_context)
+    countervar = None
+    counter = None
+    extra_context = {}
 
-    countervar, counter, extra_context = BlockTranslateParser(token.contents).top()
+    if bits.pop_lexeme('with'):
+        extra_context = parse_context_bindings(bits)
+    elif bits.pop_lexeme('count'):
+        counter = bits.parse_expression(required=True)
+        countervar = parse_as(bits, required=True)
 
     singular = []
     plural = []
@@ -255,5 +233,5 @@
 register.tag('get_available_languages', do_get_available_languages)
 register.tag('get_current_language', do_get_current_language)
 register.tag('get_current_language_bidi', do_get_current_language_bidi)
-register.tag('trans', do_translate)
-register.tag('blocktrans', do_block_translate)
+register.tag('trans', uses_token_stream(do_translate))
+register.tag('blocktrans', uses_token_stream(do_block_translate))
Index: django/templatetags/cache.py
===================================================================
--- django/templatetags/cache.py	(revision 11593)
+++ django/templatetags/cache.py	(working copy)
@@ -1,30 +1,30 @@
-from django.template import Library, Node, TemplateSyntaxError, Variable, VariableDoesNotExist
-from django.template import resolve_variable
+from django.template import Library, Node, TemplateSyntaxError
+from django.template.parser import uses_token_stream
+from django.template.expressions import LookupError
 from django.core.cache import cache
-from django.utils.encoding import force_unicode
 from django.utils.http import urlquote
 from django.utils.hashcompat import md5_constructor
 
 register = Library()
 
 class CacheNode(Node):
-    def __init__(self, nodelist, expire_time_var, fragment_name, vary_on):
+    def __init__(self, nodelist, expire_time, fragment_name, vary_on):
         self.nodelist = nodelist
-        self.expire_time_var = Variable(expire_time_var)
+        self.expire_time = expire_time
         self.fragment_name = fragment_name
         self.vary_on = vary_on
 
     def render(self, context):
         try:
-            expire_time = self.expire_time_var.resolve(context)
-        except VariableDoesNotExist:
-            raise TemplateSyntaxError('"cache" tag got an unknkown variable: %r' % self.expire_time_var.var)
+            expire_time = self.expire_time.resolve(context)
+        except LookupError:
+            raise TemplateSyntaxError('"cache" tag got an unknkown variable: %r' % self.expire_time)
         try:
             expire_time = int(expire_time)
         except (ValueError, TypeError):
             raise TemplateSyntaxError('"cache" tag got a non-integer timeout value: %r' % expire_time)
         # Build a unicode key for this fragment and all vary-on's.
-        args = md5_constructor(u':'.join([urlquote(resolve_variable(var, context)) for var in self.vary_on]))
+        args = md5_constructor(u':'.join([urlquote(exp.resolve(context)) for exp in self.vary_on]))
         cache_key = 'template.cache.%s.%s' % (self.fragment_name, args.hexdigest())
         value = cache.get(cache_key)
         if value is None:
@@ -32,7 +32,8 @@
             cache.set(cache_key, value, expire_time)
         return value
 
-def do_cache(parser, token):
+#@uses_token_stream
+def do_cache(parser, bits):
     """
     This will cache the contents of a template fragment for a given amount
     of time.
@@ -53,11 +54,10 @@
 
     Each unique set of arguments will result in a unique cache entry.
     """
-    nodelist = parser.parse(('endcache',))
-    parser.delete_first_token()
-    tokens = token.contents.split()
-    if len(tokens) < 3:
-        raise TemplateSyntaxError(u"'%r' tag requires at least 2 arguments." % tokens[0])
-    return CacheNode(nodelist, tokens[1], tokens[2], tokens[3:])
+    nodelist = parser.parse_nodelist('endcache')
+    expire_time = bits.parse_expression(required=True)
+    fragment_name = bits.pop_name(required=True)
+    vary_on = bits.parse_expression_list()
+    return CacheNode(nodelist, expire_time, fragment_name, vary_on)
 
-register.tag('cache', do_cache)
+register.tag('cache', uses_token_stream(do_cache))
Index: django/contrib/comments/templatetags/comments.py
===================================================================
--- django/contrib/comments/templatetags/comments.py	(revision 11593)
+++ django/contrib/comments/templatetags/comments.py	(working copy)
@@ -1,5 +1,7 @@
 from django import template
+from django.template.parser import uses_token_stream, TokenSyntaxError
 from django.template.loader import render_to_string
+from django.template.utils import parse_as
 from django.conf import settings
 from django.contrib.contenttypes.models import ContentType
 from django.contrib import comments
@@ -13,36 +15,30 @@
     Looks a bit strange, but the subclasses below should make this a bit more
     obvious.
     """
-
     #@classmethod
-    def handle_token(cls, parser, token):
+    def handle_token(cls, parser, bits):
         """Class method to parse get_comment_list/count/form and return a Node."""
-        tokens = token.contents.split()
-        if tokens[1] != 'for':
-            raise template.TemplateSyntaxError("Second argument in %r tag must be 'for'" % tokens[0])
-
-        # {% get_whatever for obj as varname %}
-        if len(tokens) == 5:
-            if tokens[3] != 'as':
-                raise template.TemplateSyntaxError("Third argument in %r must be 'as'" % tokens[0])
+        bits.pop_lexeme('for', required=True)
+        try:
+            # {% get_whatever for app.model pk as varname %}
+            app_and_model = bits.parse_string(bare=True)
+            if bits.pop_lexeme('as'):
+                bits.pushback() # pushback "as"
+                bits.pushback() # pushback app_and_model
+                raise TokenSyntaxError
+            pk = bits.parse_expression(required=True)
+            varname = parse_as(bits, required=True)
             return cls(
-                object_expr = parser.compile_filter(tokens[2]),
-                as_varname = tokens[4],
-            )
+                ctype=BaseCommentNode.lookup_content_type(app_and_model, bits.name),
+                object_pk_expr = pk,
+                as_varname = varname
+            )            
+        except TokenSyntaxError:        
+            # {% get_whatever for obj as varname %}
+            obj = bits.parse_expression(required=True)
+            varname = parse_as(bits, required=True)
+            return cls(object_expr=obj, as_varname = varname)
 
-        # {% get_whatever for app.model pk as varname %}
-        elif len(tokens) == 6:
-            if tokens[4] != 'as':
-                raise template.TemplateSyntaxError("Fourth argument in %r must be 'as'" % tokens[0])
-            return cls(
-                ctype = BaseCommentNode.lookup_content_type(tokens[2], tokens[0]),
-                object_pk_expr = parser.compile_filter(tokens[3]),
-                as_varname = tokens[5]
-            )
-
-        else:
-            raise template.TemplateSyntaxError("%r tag requires 4 or 5 arguments" % tokens[0])
-
     handle_token = classmethod(handle_token)
 
     #@staticmethod
@@ -136,22 +132,24 @@
     """Render the comment form directly"""
 
     #@classmethod
-    def handle_token(cls, parser, token):
+    def handle_token(cls, parser, bits):
         """Class method to parse render_comment_form and return a Node."""
-        tokens = token.contents.split()
-        if tokens[1] != 'for':
-            raise template.TemplateSyntaxError("Second argument in %r tag must be 'for'" % tokens[0])
-
-        # {% render_comment_form for obj %}
-        if len(tokens) == 3:
-            return cls(object_expr=parser.compile_filter(tokens[2]))
-
-        # {% render_comment_form for app.models pk %}
-        elif len(tokens) == 4:
-            return cls(
-                ctype = BaseCommentNode.lookup_content_type(tokens[2], tokens[0]),
-                object_pk_expr = parser.compile_filter(tokens[3])
-            )
+        bits.pop_lexeme('for', required=True)
+        try:
+            # {% render_comment_form for app.models pk %}
+            app_and_model = bits.parse_string(bare=True)
+            try:
+                pk = bits.parse_expression()
+                return cls(
+                    ctype = BaseCommentNode.lookup_content_type(app_and_model, bits.name),
+                    object_pk_expr = pk
+                )                
+            except TokenSyntaxError:
+                bits.pushback()
+                raise
+        except TokenSyntaxError:
+            # {% render_comment_form for obj %}            
+            return cls(object_expr=bits.parse_expression(required=True))
     handle_token = classmethod(handle_token)
 
     def render(self, context):
@@ -174,6 +172,7 @@
 # wrapper function that just exists to hold the docstring.
 
 #@register.tag
+#@uses_token_stream
 def get_comment_count(parser, token):
     """
     Gets the comment count for the given params and populates the template
@@ -195,6 +194,7 @@
     return CommentCountNode.handle_token(parser, token)
 
 #@register.tag
+#@uses_token_stream
 def get_comment_list(parser, token):
     """
     Gets the list of comments for the given params and populates the template
@@ -217,6 +217,7 @@
     return CommentListNode.handle_token(parser, token)
 
 #@register.tag
+#@uses_token_stream
 def get_comment_form(parser, token):
     """
     Get a (new) form object to post a new comment.
@@ -252,8 +253,8 @@
     """
     return comments.get_form_target()
 
-register.tag(get_comment_count)
-register.tag(get_comment_list)
-register.tag(get_comment_form)
-register.tag(render_comment_form)
+register.tag(uses_token_stream(get_comment_count))
+register.tag(uses_token_stream(get_comment_list))
+register.tag(uses_token_stream(get_comment_form))
+register.tag(uses_token_stream(render_comment_form))
 register.simple_tag(comment_form_target)
